#ifndef BALL_H
#define BALL_H

	#include <Inventor/nodes/SoNode.h>
	#include <Inventor/nodes/SoSeparator.h>
	#include <Inventor/nodes/SoSphere.h>
	#include <Inventor/nodes/SoTranslation.h>
	#include <Inventor/nodes/SoBaseColor.h>
	#include <Inventor/SbColor.h>
	#include <Inventor/nodes/SoComplexity.h>

	
	#include "MassPoint.h"

	class Ball: public MassPoint {

		public:
			Ball(float x, float y, float z, float vx, float vy, float vz, float m, float r, float dt);
			Ball();
			virtual int numPoints();
			float getRadius();
			SoNode* getNode();
			virtual void calculateForces();
			virtual void step();
			void reset(float x, float y, float z, float vx, float vy, float vz);
			float tempMass;
			

		private:
			float radius;
			SoTranslation *translation;
			SoBaseColor *color;
			SoComplexity *complexity;

	};

#endif