#ifndef COLLISION_DETECTOR_H
#define COLLISION_DETECTOR_H

	#include <Inventor/lists/SbList.h>
	#include <Inventor/SbLinear.h>
	#include "ElasticMembran.h"
	#include "Ball.h"

	// elasticity of collision
	//		0 = absolut inelastic
	//		1 = perfectly elastic
	#define E		0.0f
	#define OFFSET	0.005f
	#define V_DIFF	0.99f

	class CollisionDetector {
		public:
			CollisionDetector();
			void callback();
			void calculateForces();
			void addBall(Ball *ball);
			void addMembran(ElasticMembran *membran);

		private:
			float *oldMembranState;
			float *oldBallState;
			SbList<Ball> balls;
			SbList<ElasticMembran> membrans;
			void applyForce(Ball ball, Point *points, int numPoints);
			void collideBallWithMembran(Ball ball, Point *points, int numPoints);
			void handleBallPointCollision(Ball ball, Point point, SbVec3f vec, float radius);
	};

#endif