#ifndef ODE_SYSTEM_H
#define ODE_SYSTEM_H

	#include <stdio.h>

	/**
	 * Interface used by the Solver
	 */
	class ODE_System {
		public:

			/**
			* array containing the positions of all points in [0, (N*M*3)-1]
			* and the velocities of of all points in [(N*M*3), (N*M*6)-1]
			*/
			float *state;

			/**
			 * dimension of the array 'state'
			 */
			virtual int getDimension();

			/**
			 * Calculates the derivatives of the state
			 */
			virtual void calculateDerivatives (float derivatives[]);

			/**
			 * Calculate only the accelerations of the state:
			 */
			virtual void calculateAccelerations(float accelerations[]);


		private:
	};

#endif