#ifndef MY_APP_H
#define MY_APP_H


	#include <Inventor/Win/SoWin.h>
	#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
	#include <Inventor/nodes/SoSeparator.h>
	#include <Inventor/sensors/SoTimerSensor.h>
	#include <Inventor/SbTime.h>
	#include <Inventor/nodes/SoPerspectiveCamera.h>
	#include <Inventor/nodes/SoDirectionalLight.h>
	#include <Inventor/nodes/SoSpotLight.h>
	#include <Inventor/events/SoKeyboardEvent.h>
	#include <Inventor/events/SoEvent.h>
	#include <Inventor/nodes/SoEventCallback.h>

	#include <Inventor/C/tidbits.h>

	#include "CollisionDetector.h"
	#include "ElasticMembran.h"
	#include "Ball.h"

	#define INTERVAL 0.005f		// The SoTimerSensor Intervall length

	// const for the membrane
	#define N      51		// num of columns
	#define M      51		// num of rows
	#define DX      0.2f	// x-coord difference between 2 neighbouring membran points
	#define DY      0.2f	// y-coord difference between 2 neighbouring membran points
	#define MASS	0.01f	// mass of a point

	// const for the ball
	#define BALL_MASS	10.0f	// mass of a ball
	#define RADIUS		 2.0f	// radius of a ball
//	#define BALL_MASS	3.0f	// mass of a ball
//	#define RADIUS		1.0f	// radius of a ball


	ElasticMembran *em;
	Ball *ball;
	CollisionDetector *detector;
	SoTimerSensor *timeSensor;
	void callback(void *data, SoSensor *s);

	void keyboardEventCallback(void *data, SoEventCallback *node);

#endif